# How to reproduce issue

## 1. Create docker base image
We use an alpine java 17 base image. You can build this by executing the following command in the root of this project

```docker build -f docker-baseimage/Dockerfile -t local/aauqa-base-java:awscrt ./docker-baseimage```

## 2. Create actual service container
We use jib to create a docker container to run the actual service

```mvn clean install jib:dockerBuild```

## 3. Spin in infrastructure
To test this issue we use a local DynamoDB endpoint.
We have a small setup described in `docker-infra/docker-compose.yaml`. You can spinup the infrastructure with the following command.

```docker-compose -f docker-infra/docker-compose.yaml up```

### 4. Run the service
When the infrastructure is running you can start the service. The service will load the DynamoDB client (using the AWS-CRT Http client).
Before it will open the endpoints we will already try to describe the DynamoDB table to test the connection.
You will notice that a fatal exception occurs during creating the AwsCrtHttpClient.

```docker run -it --rm aws-crt-example:0.0-SNAPSHOT```