package live.aaqua.awscrtexample;

import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import software.amazon.awssdk.services.dynamodb.DynamoDbAsyncClient;
import software.amazon.awssdk.services.dynamodb.model.AttributeValue;
import software.amazon.awssdk.services.dynamodb.model.ScanRequest;
import software.amazon.awssdk.services.dynamodb.model.ScanResponse;

@RestController
@RequestMapping("/")
public class ApiResource {

  @Autowired
  private DynamoDbAsyncClient dynamoDbAsyncClient;

  @Value("${dynamodb.table}")
  private String table;

  @GetMapping("/scan")
  public Flux<Map<String, AttributeValue>> scanOperation() {
    return Mono.fromFuture(dynamoDbAsyncClient.scan(ScanRequest.builder()
           .tableName(table)
       .build())).flatMapIterable(ScanResponse::items);

  }


}
